org.apache.commons.math3.distribution

## Class TDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractRealDistribution
  - - org.apache.commons.math3.distribution.TDistribution

- All Implemented Interfaces:
    java.io.Serializable, RealDistribution

      public class TDistribution
      extends AbstractRealDistribution

  Implementation of Student's t-distribution.
  Version:
    $Id: TDistribution.java 1416643 2012-12-03 19:37:14Z tn $
  See Also:
    "Student's t-distribution (Wikipedia)", "Student's t-distribution (MathWorld)", Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static double` | `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy.
    `private double` | `degreesOfFreedom` The degrees of freedom.
    `private static long` | `serialVersionUID` Serializable version identifier
    `private double` | `solverAbsoluteAccuracy` Inverse cumulative probability accuracy.

    - ### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

      `random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TDistribution(double degreesOfFreedom)` Create a t distribution using the given degrees of freedom.
    `TDistribution(double degreesOfFreedom, double inverseCumAccuracy)` Create a t distribution using the given degrees of freedom and the specified inverse cumulative probability absolute accuracy.
    `TDistribution(RandomGenerator rng, double degreesOfFreedom, double inverseCumAccuracy)` Creates a t distribution.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `cumulativeProbability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
    `double` | `density(double x)` Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
    `double` | `getDegreesOfFreedom()` Access the degrees of freedom.
    `double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
    `double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
    `protected double` | `getSolverAbsoluteAccuracy()` Returns the solver absolute accuracy for inverse cumulative computation.
    `double` | `getSupportLowerBound()` Access the lower bound of the support.
    `double` | `getSupportUpperBound()` Access the upper bound of the support.
    `boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
    `boolean` | `isSupportLowerBoundInclusive()` Whether or not the lower bound of support is in the domain of the density function.
    `boolean` | `isSupportUpperBoundInclusive()` Whether or not the upper bound of support is in the domain of the density function.

    - ### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

      `cumulativeProbability, inverseCumulativeProbability, probability, probability, reseedRandomGenerator, sample, sample`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

          public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

      Default inverse cumulative probability accuracy.
      Since:
        2.1
      See Also:
        Constant Field Values

    - #### serialVersionUID

          private static final long serialVersionUID

      Serializable version identifier
      See Also:
        Constant Field Values

    - #### degreesOfFreedom

          private final double degreesOfFreedom

      The degrees of freedom.

    - #### solverAbsoluteAccuracy

          private final double solverAbsoluteAccuracy

      Inverse cumulative probability accuracy.

  - ### Constructor Detail

    - #### TDistribution

          public TDistribution(double degreesOfFreedom)
                        throws NotStrictlyPositiveException

      Create a t distribution using the given degrees of freedom.
      Parameters:
        `degreesOfFreedom` - Degrees of freedom.
      Throws:
        `NotStrictlyPositiveException` - if `degreesOfFreedom <= 0`

    - #### TDistribution

          public TDistribution(double degreesOfFreedom,
                       double inverseCumAccuracy)
                        throws NotStrictlyPositiveException

      Create a t distribution using the given degrees of freedom and the specified inverse cumulative probability absolute accuracy.
      Parameters:
        `degreesOfFreedom` - Degrees of freedom.
        `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
      Throws:
        `NotStrictlyPositiveException` - if `degreesOfFreedom <= 0`
      Since:
        2.1

    - #### TDistribution

          public TDistribution(RandomGenerator rng,
                       double degreesOfFreedom,
                       double inverseCumAccuracy)
                        throws NotStrictlyPositiveException

      Creates a t distribution.
      Parameters:
        `rng` - Random number generator.
        `degreesOfFreedom` - Degrees of freedom.
        `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
      Throws:
        `NotStrictlyPositiveException` - if `degreesOfFreedom <= 0`
      Since:
        3.1

  - ### Method Detail

    - #### getDegreesOfFreedom

          public double getDegreesOfFreedom()

      Access the degrees of freedom.
      Returns:
        the degrees of freedom.

    - #### density

          public double density(double x)

      Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.
      Parameters:
        `x` - the point at which the PDF is evaluated
      Returns:
        the value of the probability density function at point `x`

    - #### cumulativeProbability

          public double cumulativeProbability(double x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.
      Parameters:
        `x` - the point at which the CDF is evaluated
      Returns:
        the probability that a random variable with this distribution takes a value less than or equal to `x`

    - #### getSolverAbsoluteAccuracy

          protected double getSolverAbsoluteAccuracy()

      Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.
      Overrides:
        `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
      Returns:
        the maximum absolute error in inverse cumulative probability estimates

    - #### getNumericalMean

          public double getNumericalMean()

      Use this method to get the numerical value of the mean of this distribution. For degrees of freedom parameter `df`, the mean is
      - if `df > 1` then `0`,
      - else undefined (`Double.NaN`).
      Returns:
        the mean or `Double.NaN` if it is not defined

    - #### getNumericalVariance

          public double getNumericalVariance()

      Use this method to get the numerical value of the variance of this distribution. For degrees of freedom parameter `df`, the variance is
      - if `df > 2` then `df / (df - 2)`,
      - if `1 < df <= 2` then positive infinity (`Double.POSITIVE_INFINITY`),
      - else undefined (`Double.NaN`).
      Returns:
        the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

    - #### getSupportLowerBound

          public double getSupportLowerBound()

      Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

      `inf {x in R | P(X <= x) > 0}`.

      The lower bound of the support is always negative infinity no matter the parameters.
      Returns:
        lower bound of the support (always `Double.NEGATIVE_INFINITY`)

    - #### getSupportUpperBound

          public double getSupportUpperBound()

      Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

      `inf {x in R | P(X <= x) = 1}`.

      The upper bound of the support is always positive infinity no matter the parameters.
      Returns:
        upper bound of the support (always `Double.POSITIVE_INFINITY`)

    - #### isSupportLowerBoundInclusive

          public boolean isSupportLowerBoundInclusive()

      Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.
      Returns:
        true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

    - #### isSupportUpperBoundInclusive

          public boolean isSupportUpperBoundInclusive()

      Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.
      Returns:
        true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

    - #### isSupportConnected

          public boolean isSupportConnected()

      Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.
      Returns:
        `true`

Copyright (c) 2003-2013 Apache Software Foundation